'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _audio = require('./audio');

var _audio2 = _interopRequireDefault(_audio);

var _searchbox = require('./searchbox');

var _searchbox2 = _interopRequireDefault(_searchbox);

var _searchresults = require('./searchresults');

var _searchresults2 = _interopRequireDefault(_searchresults);

var _transcript = require('./transcript');

var _transcript2 = _interopRequireDefault(_transcript);

var _search = require('./search');

var search = _interopRequireWildcard(_search);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TranscriptPlayer = (function (_React$Component) {
  (0, _inherits3.default)(TranscriptPlayer, _React$Component);

  function TranscriptPlayer(props) {
    (0, _classCallCheck3.default)(this, TranscriptPlayer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TranscriptPlayer).call(this, props));

    _this.handleTimeUpdate = _this.handleTimeUpdate.bind(_this);
    _this.handleEnded = _this.handleEnded.bind(_this);
    _this.handleSeekRequest = _this.handleSeekRequest.bind(_this);
    _this.handleQuery = _this.handleQuery.bind(_this);
    _this.handleNavigateResult = _this.handleNavigateResult.bind(_this);
    _this.state = { time: 0,
      seekTime: null,
      ended: false,
      query: '',
      searchResults: search.execute(props.transcript.turns),
      resultIndex: null
    };
    return _this;
  }

  (0, _createClass3.default)(TranscriptPlayer, [{
    key: 'handleTimeUpdate',
    value: function handleTimeUpdate(unrounded_time) {
      var time = Math.round(unrounded_time);
      if (time === this.state.seekTime) {
        this.setState({ time: time, seekTime: null });
      } else {
        this.setState({ time: time });
      }
    }
  }, {
    key: 'handleEnded',
    value: function handleEnded(ended) {
      this.setState({ ended: ended });
    }
  }, {
    key: 'handleSeekRequest',
    value: function handleSeekRequest(seekTime) {
      this.setState({ seekTime: seekTime, ended: false });
    }
  }, {
    key: 'handleQuery',
    value: function handleQuery(query) {
      var re = query === '' ? null : new RegExp(query, 'ig'),
          results = search.execute(this.props.transcript.turns, re);
      this.setState({ query: query, searchResults: results, resultIndex: null });
    }
  }, {
    key: 'handleNavigateResult',
    value: function handleNavigateResult(direction) {
      if (this.state.searchResults.get('count') === 0) return;
      var times = this.state.searchResults.get('times');
      var index = this.state.resultIndex;
      if (direction === 'forward') {
        index = index === null ? 0 : index + 1;
        if (index === times.size) index = 0;
      } else {
        index = index === null ? times.size - 1 : index - 1;
        if (index < 0) index = times.size - 1;
      }
      this.setState({ resultIndex: index });
      this.handleSeekRequest(times.get(index));
    }
  }, {
    key: 'render',
    value: function render() {
      var searchResults = _react2.default.createElement(_searchresults2.default, {
        count: this.state.searchResults.get('count'),
        onNavigateResult: this.handleNavigateResult
      });
      return _react2.default.createElement(
        'div',
        { className: 'container flex flex-column border' },
        _react2.default.createElement(_audio2.default, {
          media: this.props.transcript.media,
          onEnded: this.handleEnded,
          onTimeUpdate: this.handleTimeUpdate,
          seekTime: this.state.seekTime
        }),
        _react2.default.createElement(
          'div',
          { className: 'clearfix p1 mb1' },
          _react2.default.createElement(_searchbox2.default, {
            onQuery: this.handleQuery,
            query: this.state.query
          }),
          this.state.query ? searchResults : ''
        ),
        _react2.default.createElement(_transcript2.default, {
          ended: this.state.ended,
          highlights: this.state.searchResults.get('matches'),
          key: this.props.transcript.id,
          onSeekRequest: this.handleSeekRequest,
          speakers: this.props.transcript.speakers,
          time: this.state.time,
          turns: this.props.transcript.turns
        })
      );
    }
  }]);
  return TranscriptPlayer;
})(_react2.default.Component);

TranscriptPlayer.propTypes = { transcript: _react2.default.PropTypes.shape({ id: _react2.default.PropTypes.string,
    media: _react2.default.PropTypes.string,
    speakers: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.string),
    turns: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object)
  }).isRequired
};
exports.default = TranscriptPlayer;